/**
  ${moduleGroupNameUpperCase} Generated Driver API Header File

  @Company
    Microchip Technology Inc.

  @File Name
    ${moduleGroupNameLowerCase}_host_interface.h

  @Summary
    This is the generated driver interface header file for the ${moduleGroupNameUpperCase} driver.

  @Description
    This file provides common enumerations for ${moduleGroupNameUpperCase} driver.
    Generation Information :
        Product Revision  :  ${productName} - ${productVersion}
        Device            :  ${selectedDevice}
        Driver Version    :  1.0.0
    The generated drivers are tested against the following:
        Compiler          :  ${compiler}
        MPLAB             :  ${tool}
*/

${disclaimer}

#ifndef ${moduleGroupNameUpperCase}_INTERFACE_H
#define ${moduleGroupNameUpperCase}_INTERFACE_H
/**
  Section: Included Files
*/
#include <stdbool.h>
#include <stdint.h>
#include <xc.h>
#include "${moduleNameLowerCase}_host_types.h"
    
/**
  ${moduleGroupNameUpperCase}_HOST_INTERFACE

  @Description
    Structure containing the function pointers of ${moduleGroupNameUpperCase} driver.
 */
struct ${moduleGroupNameUpperCase}_HOST_INTERFACE
{   
    void (*Initialize)(void);
    bool (*Write)(uint16_t address, uint8_t *data, size_t dataLength);
    bool (*Read)(uint16_t address, uint8_t *data, size_t dataLength);
    bool (*WriteRead)(uint16_t address, uint8_t *writeData, size_t writeLength, uint8_t *readData, size_t readLength);
    bool (*TransferSetup)(struct ${moduleGroupNameUpperCase}_TRANSFER_SETUP* setup, uint32_t srcClkFreq);
    enum ${moduleGroupNameUpperCase}_ERROR (*ErrorGet)(void);
    bool (*IsBusy)(void);
    void (*Callback)(void);
    void (*CallbackRegister)(void (*handler)(void));
};

#endif // end of ${moduleGroupNameUpperCase}_INTERFACE_H