/**
  ${moduleNameUpperCase} Generated Driver File

  @Company
    Microchip Technology Inc.

  @File Name
    ${moduleNameLowerCase}.c

  @Summary
    This is the generated driver implementation file for the ${moduleNameUpperCase} driver.

  @Description
    This file provides common enumerations for ${moduleNameUpperCase} driver.
    Generation Information :
        Product Revision  :  ${productName} - ${productVersion}
        Device            :  ${selectedDevice}
        Driver Version    :  1.0.1
    The generated drivers are tested against the following:
        Compiler          :  ${compiler} or later
        MPLAB             :  ${tool}
*/
${disclaimer}

#include "../${header.name}"
#include <stdbool.h>
#include <stdlib.h>

/***************************************************************************/
// I2C STATES
typedef enum {
    I2C${instanceNumber}_IDLE = 0,
    I2C${instanceNumber}_SEND_ADR_READ,
    I2C${instanceNumber}_SEND_ADR_WRITE,
    I2C${instanceNumber}_TX,
    I2C${instanceNumber}_RX,
    I2C${instanceNumber}_TX_EMPTY,
    I2C${instanceNumber}_SEND_RESTART_READ,
    I2C${instanceNumber}_SEND_RESTART_WRITE,
    I2C${instanceNumber}_SEND_RESTART,
    I2C${instanceNumber}_SEND_STOP,
    I2C${instanceNumber}_RX_DO_ACK,
    I2C${instanceNumber}_TX_DO_ACK,
    I2C${instanceNumber}_RX_DO_RX_NACK_STOP,
    I2C${instanceNumber}_RX_DO_NACK_RESTART,
    I2C${instanceNumber}_RESET,
    I2C${instanceNumber}_ADDRESS_NACK,
    I2C${instanceNumber}_BUS_COLLISION,
    I2C${instanceNumber}_BUS_ERROR
} ${componentNameLowerCase}_fsm_states_t;

// I2C Event Callback List
typedef enum {
    I2C${instanceNumber}_DATA_COMPLETE = 0,
    I2C${instanceNumber}_WRITE_COLLISION,
    I2C${instanceNumber}_ADDRESSNACK,
    I2C${instanceNumber}_DATA_NACK,
    I2C${instanceNumber}_TIMEOUT,
    I2C${instanceNumber}_NULL
} ${componentName}_callbackIndex_t;

typedef struct
{
    size_t len;
    uint8_t *data;
} ${componentNameLowerCase}_buffer_t;

static  ${componentNameLowerCase}_operations_t rdBlkRegCompleteHandler(void *ptr);

// I2C Status Structure
typedef struct {
    ${componentNameLowerCase}_callback_t callbackTable[6];
    void *       callbackPayload[6];
    uint16_t         timeout;
    uint16_t         timeout_value;
    ${componentNameLowerCase}_address_t    address;
    uint8_t *        data_ptr;
    size_t           data_length;
    ${componentNameLowerCase}_fsm_states_t state;
    ${componentNameLowerCase}_error_t      error;
    unsigned         addressNACKCheck : 1;
    unsigned         busy : 1;
    unsigned         inUse : 1;
    unsigned         bufferFree : 1;
    /*if timeoutDriverEnabled
    timerStruct_t timeout;
    */
} ${componentName}_status_t;
typedef ${componentNameLowerCase}_fsm_states_t(stateHandlerFunction)(void);

/* I2C Interfaces */
void ${api.Poller.name}(void);

/* I2C Internal API's */
/* HOST */
static inline void ${componentName}_HostOpen(void);
static inline void ${componentName}_HostClose(void);
static inline uint8_t ${componentName}_HostGetRxData(void);
static inline void ${componentName}_HostTxData(uint8_t d);
static inline void ${componentName}_HostTxAddr(uint8_t d);
static inline void ${componentName}_HostResetBus(void);
static inline void ${componentName}_HostIsRxOrTx(void);
static inline void ${componentName}_HostStop(void);
static inline bool ${componentName}_HostIsNack(void);
static inline void ${componentName}_HostSendAck(void);
static inline void ${componentName}_HostSendNack(void);
static inline void ${componentName}_HostClearBusCollision(void);
static inline bool ${componentName}_HostBusErrorOverride();
static inline bool ${componentName}_HostArbitrationlostOverride(void);
static inline void ${componentName}_HostEnableIrq(void);
static inline bool ${componentName}_HostIsIrqEnabled(void);
static inline void ${componentName}_HostDisableIrq(void);
static inline void ${componentName}_HostClearIrq(void);
static inline void ${componentName}_HostWaitForEvent(void);
static void ${componentName}_set_callback(${componentName}_callbackIndex_t idx, ${componentNameLowerCase}_callback_t cb, void *funPtr);
static ${componentNameLowerCase}_operations_t ${componentName}_RETURN_STOP(void *funPtr);
static ${componentNameLowerCase}_operations_t ${componentName}_RETURN_RESET(void *funPtr);
static void ${componentName}_HostIsr(void);

/* Helper Functions */
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_IDLE(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_ADR_READ(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_ADR_WRITE(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_TX(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_TX_EMPTY(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_RESTART_READ(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_RESTART_WRITE(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_RESTART(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_STOP(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX_ACK(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_TX_ACK(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX_NACK_STOP(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX_NACK_RESTART(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RESET(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_ADDRESS_NACK(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_BUS_COLLISION(void);
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_BUS_ERROR(void);

typedef ${componentNameLowerCase}_fsm_states_t(stateHandlerFunction)(void);
stateHandlerFunction *${componentName}_fsmStateTable[] = {
    ${componentName}_DO_IDLE,               // I2C_IDLE
    ${componentName}_DO_SEND_ADR_READ,      // I2C_SEND_ADR_READ
    ${componentName}_DO_SEND_ADR_WRITE,     // I2C_SEND_ADR_WRITE
    ${componentName}_DO_TX,                 // I2C_TX
    ${componentName}_DO_RX,                 // I2C_RX
    ${componentName}_DO_TX_EMPTY,           // I2C_TX_EMPTY
    ${componentName}_DO_SEND_RESTART_READ,  // I2C_SEND_RESTART_READ
    ${componentName}_DO_SEND_RESTART_WRITE, // I2C_SEND_RESTART_WRITE
    ${componentName}_DO_SEND_RESTART,       // I2C_SEND_RESTART
    ${componentName}_DO_SEND_STOP,          // I2C_SEND_STOP
    ${componentName}_DO_RX_ACK,          // I2C_RX_DO_ACK
    ${componentName}_DO_TX_ACK,          // I2C_TX_DO_ACK
    ${componentName}_DO_RX_NACK_STOP,       // I2C_RX_DO_NACK_STOP
    ${componentName}_DO_RX_NACK_RESTART,    // I2C_RX_DO_NACK_RESTART
    ${componentName}_DO_RESET,              // I2C_RESET
    ${componentName}_DO_ADDRESS_NACK,    // I2C_ADDRESS_NACK
    ${componentName}_DO_BUS_COLLISION,      // I2C_BUS_COLLISION
    ${componentName}_DO_BUS_ERROR           // I2C_BUS_ERROR
};

/**
  Section: Driver Interface
*/
const struct ${moduleGroupNameUpperCase}_HOST_INTERFACE ${componentNameLowerCase}_host_Interface = {
  .Initialize = ${componentNameUpperCase}_Initialize,
  .Write = ${componentNameUpperCase}_Write,
  .Read = ${componentNameUpperCase}_Read,
  .WriteRead = ${componentNameUpperCase}_WriteRead,
  .TransferSetup = NULL,
  .ErrorGet = ${componentNameUpperCase}_ErrorGet,
  .IsBusy = ${componentNameUpperCase}_IsBusy,
  .Callback = ${componentNameUpperCase}_Callback,
  .CallbackRegister = ${componentNameUpperCase}_CallbackRegister
};

/**
 Section: Private Variable Definitions
*/
static void (*${componentNameUpperCase}_InterruptHandler)(void) = NULL;
${componentNameUpperCase}_status_t ${componentNameUpperCase}_Status = {0};
enum ${moduleGroupNameUpperCase}_ERROR ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_ERROR_NONE;

void ${api.SetDataCompleteCallback.name}(${componentNameLowerCase}_callback_t cb, void *funPtr)
{
    ${componentName}_set_callback(I2C${instanceNumber}_DATA_COMPLETE, cb, funPtr);
}

void ${api.SetWriteCollisionCallback.name}(${componentNameLowerCase}_callback_t cb, void *funPtr)
{
    ${componentName}_set_callback(I2C${instanceNumber}_WRITE_COLLISION, cb, funPtr);
}

void ${api.SetAddressNackCallback.name}(${componentNameLowerCase}_callback_t cb, void *funPtr)
{
    ${componentName}_set_callback(I2C${instanceNumber}_ADDRESSNACK, cb, funPtr);
}

void ${api.SetDataNackCallback.name}(${componentNameLowerCase}_callback_t cb, void *funPtr)
{
    ${componentName}_set_callback(I2C${instanceNumber}_DATA_NACK, cb, funPtr);
}

void ${api.SetTimeoutCallback.name}(${componentNameLowerCase}_callback_t cb, void *funPtr)
{
    ${componentName}_set_callback(I2C${instanceNumber}_TIMEOUT, cb, funPtr);
}

void ${api.Initialize.name}(void)
{
    <#if CTRLA??>
    //${CTRLA.comment}
    ${moduleInstance}.${CTRLA.name} = ${CTRLA.valueAsHex};
    
    </#if>
    <#if DBGCTRL??>
    //Debug Run
    ${moduleInstance}.${DBGCTRL.name} = ${DBGCTRL.valueAsHex};
    
    </#if>
    <#if MBAUD??>
    //Host Baud Rate Control
    ${moduleInstance}.${MBAUD.name} = (uint8_t)${componentNameUpperCase}_BAUD(${SCL_Frequency}, ${Trise});
    
    </#if>
    <#if MCTRLA??>
    //${MCTRLA.comment}
    ${moduleInstance}.${MCTRLA.name} = ${MCTRLA.valueAsHex};
    
    </#if>
    <#if MSTATUS??>
    //${MSTATUS.comment}
    ${moduleInstance}.${MSTATUS.name} = ${MSTATUS.valueAsHex};
    
    </#if>
    <#if MADDR??>
    //Host Address
    ${moduleInstance}.${MADDR.name} = ${MADDR.valueAsHex};
    
    </#if>
    <#if MCTRLB??>
    //${MCTRLB.comment}
    ${moduleInstance}.${MCTRLB.name} = ${MCTRLB.valueAsHex};
    
    </#if>
    <#if MDATA??>
    //Host Data
    ${moduleInstance}.${MDATA.name} = ${MDATA.valueAsHex};
    
    </#if>
}

// when you call open, you supply a device address.
// if you get the bus, the function returns true
${componentNameLowerCase}_error_t ${api.Open.name}(${componentNameLowerCase}_address_t address)
{
    ${componentNameLowerCase}_error_t ret = I2C${instanceNumber}_BUSY;

    if (!${componentName}_Status.inUse) {
        ${componentName}_Status.address          = address;
        ${componentName}_Status.busy             = 0;
        ${componentName}_Status.inUse            = 1;
        ${componentName}_Status.addressNACKCheck = 0;
        ${componentName}_Status.state            = I2C${instanceNumber}_RESET;
        ${componentName}_Status.timeout_value    = 500; // MCC should determine a reasonable starting value here.
        ${componentName}_Status.bufferFree       = 1;
        
        // set all the call backs to a default of sending stop
        ${componentName}_Status.callbackTable[I2C${instanceNumber}_DATA_COMPLETE]     = ${componentName}_RETURN_STOP;
        ${componentName}_Status.callbackPayload[I2C${instanceNumber}_DATA_COMPLETE]   = NULL;
        ${componentName}_Status.callbackTable[I2C${instanceNumber}_WRITE_COLLISION]   = ${componentName}_RETURN_STOP;
        ${componentName}_Status.callbackPayload[I2C${instanceNumber}_WRITE_COLLISION] = NULL;
        ${componentName}_Status.callbackTable[I2C${instanceNumber}_ADDRESSNACK]      = ${componentName}_RETURN_STOP;
        ${componentName}_Status.callbackPayload[I2C${instanceNumber}_ADDRESSNACK]    = NULL;
        ${componentName}_Status.callbackTable[I2C${instanceNumber}_DATA_NACK]         = ${componentName}_RETURN_STOP;
        ${componentName}_Status.callbackPayload[I2C${instanceNumber}_DATA_NACK]       = NULL;
        ${componentName}_Status.callbackTable[I2C${instanceNumber}_TIMEOUT]          = ${componentName}_RETURN_RESET;
        ${componentName}_Status.callbackPayload[I2C${instanceNumber}_TIMEOUT]        = NULL;

        ${componentName}_HostResetBus();
        // Reset module
        ${componentName}_HostClearIrq();
        ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_ERROR_NONE;

        ret = I2C${instanceNumber}_NOERR;
    }
    return ret;
}

void ${api.SetAddress.name}(${componentNameLowerCase}_address_t address)
{
    ${componentName}_Status.address = address;
}

// close the bus if it is not busy
${componentNameLowerCase}_error_t ${api.Close.name}(void)
{
    ${componentNameLowerCase}_error_t ret = I2C${instanceNumber}_BUSY;
    // Bus is in error state, reset I2C hardware and report error
    if (${componentName}_HostBusErrorOverride()) {
        ${componentName}_Status.busy  = false;
        ${componentName}_Status.error = I2C${instanceNumber}_FAIL;
    }
    if (!${componentName}_Status.busy) {
        ${componentName}_Status.inUse = 0;
        // close it down
        ${componentName}_Status.address = 0xff; // 8-bit address is invalid so this is FREE
        ${componentName}_HostClearIrq();
        ${componentName}_HostDisableIrq();
        ret = ${componentName}_Status.error;
    }
    return ret;
}

void ${api.SetTimeout.name}(uint8_t to)
{
    ${componentName}_HostDisableIrq();
    ${componentName}_Status.timeout_value = to;
    ${componentName}_HostEnableIrq();
}

void ${api.SetBuffer.name}(void *buffer, size_t bufferSize)
{
    if (${componentName}_Status.bufferFree) {
        ${componentName}_Status.data_ptr    = buffer;
        ${componentName}_Status.data_length = bufferSize;
        ${componentName}_Status.bufferFree  = false;
    }
}

${componentNameLowerCase}_error_t ${componentName}_HostRead(void)
{
    ${componentNameLowerCase}_error_t returnValue = I2C${instanceNumber}_BUSY;
    if (!${componentName}_Status.busy) {
        ${componentName}_Status.busy = true;
        returnValue = ${componentNameUpperCase}_NOERR;
        ${componentNameUpperCase}_Status.state = ${componentNameUpperCase}_SEND_ADR_READ;
        ${componentName}_HostIsr();
        ${api.Poller.name}();
    }
    return returnValue;
}

${componentNameLowerCase}_error_t ${componentName}_HostWrite(void)
{
    ${componentNameLowerCase}_error_t returnValue = ${componentNameUpperCase}_BUSY;
    if(!${componentNameUpperCase}_Status.busy)
    {
        ${componentNameUpperCase}_Status.busy = true;
        returnValue = ${componentNameUpperCase}_NOERR;
        ${componentNameUpperCase}_Status.state = ${componentNameUpperCase}_SEND_ADR_WRITE;
        ${componentName}_HostIsr();
        ${componentNameUpperCase}_Poller();
    }
    return returnValue;
}

/************************************************************************/
/* Helper Functions                                                     */
/************************************************************************/

void ${api.Poller.name}(void)
{
    while (${componentName}_Status.busy)
    {
        ${componentName}_HostWaitForEvent();
        ${componentName}_HostIsr();
    }
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RESET(void)
{
    ${componentName}_HostResetBus();
    ${componentName}_Status.busy  = false; // Bus Free
    ${componentName}_Status.error = I2C${instanceNumber}_NOERR;
    return I2C${instanceNumber}_RESET; // park the FSM on reset
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_IDLE(void)
{
    ${componentName}_Status.busy  = false; // Bus Free
    ${componentName}_Status.error = I2C${instanceNumber}_NOERR;
    return I2C${instanceNumber}_IDLE; // park the FSM on IDLE
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_RESTART_READ(void)
{
    return ${componentName}_DO_SEND_ADR_READ();
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_RESTART_WRITE(void)
{
    return ${componentName}_DO_SEND_ADR_WRITE();
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_RESTART(void)
{
    return ${componentName}_DO_SEND_ADR_READ();
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_STOP(void)
{
    ${componentName}_HostStop();
    return ${componentName}_DO_IDLE();
}

// TODO: probably need 2 addressNACK's one from read and one from write.
//       the do NACK before RESTART or STOP is a special case that a new state simplifies.
static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_ADDRESS_NACK(void)
{
    ${componentName}_Status.addressNACKCheck = 0;
    ${componentName}_Status.error            = I2C${instanceNumber}_FAIL;
    switch (${componentName}_Status.callbackTable[I2C${instanceNumber}_ADDRESSNACK](${componentName}_Status.callbackPayload[I2C${instanceNumber}_ADDRESSNACK])) {
    case I2C${instanceNumber}_RESTART_READ:
        return ${componentName}_DO_SEND_RESTART_READ();
    case I2C${instanceNumber}_RESTART_WRITE:
        return ${componentName}_DO_SEND_RESTART_WRITE();
    default:
        ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_ERROR_NACK;
        return ${componentName}_DO_SEND_STOP();
    }
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_ADR_READ(void)
{

    ${componentName}_Status.addressNACKCheck = 1;
    ${componentName}_HostTxAddr(${componentName}_Status.address << 1 | 1);
    return I2C${instanceNumber}_RX;
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_SEND_ADR_WRITE(void)
{

    ${componentName}_Status.addressNACKCheck = 1;
    ${componentName}_HostTxAddr(${componentName}_Status.address << 1);
    return I2C${instanceNumber}_TX;
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX_ACK(void)
{
    ${componentName}_HostSendAck();
    return I2C${instanceNumber}_RX;
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_TX_ACK(void)
{
    ${componentName}_HostSendAck();
    return I2C${instanceNumber}_TX;
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX_NACK_STOP(void)
{
    ${componentName}_HostSendNack();
    ${componentName}_HostStop();
    return ${componentName}_DO_IDLE();
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX_NACK_RESTART(void)
{
    ${componentName}_HostSendNack();
    return I2C${instanceNumber}_SEND_RESTART;
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_TX(void)
{
    if (${componentName}_HostIsNack()) // Client replied with NACK
    {
        switch (${componentName}_Status.callbackTable[I2C${instanceNumber}_DATA_NACK](${componentName}_Status.callbackPayload[I2C${instanceNumber}_DATA_NACK])) {
        case I2C${instanceNumber}_RESTART_READ:
            return ${componentName}_DO_SEND_RESTART_READ();
        case I2C${instanceNumber}_RESTART_WRITE:
            return ${componentName}_DO_SEND_RESTART_WRITE();
        default:
        case I2C${instanceNumber}_CONTINUE:
        case I2C${instanceNumber}_STOP:
            return ${componentName}_DO_SEND_STOP();
        }
    } else {
        ${componentName}_Status.addressNACKCheck = 0;
        ${componentName}_HostTxData(*${componentName}_Status.data_ptr++);
        return (--${componentName}_Status.data_length) ? I2C${instanceNumber}_TX : I2C${instanceNumber}_TX_EMPTY;
    }
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_RX(void)
{
    ${componentName}_Status.addressNACKCheck = 0;

    if (${componentName}_Status.data_length == 1)
        ${componentName}_HostSendNack(); // Next byte will be last to be received, setup NACK
    else
        ${componentName}_HostSendAck(); // More bytes to receive, setup ACK

    if (--${componentName}_Status.data_length) {
        *${componentName}_Status.data_ptr = ${componentName}_HostGetRxData();
        ${componentName}_Status.data_ptr++;
        ${componentName}_HostIsRxOrTx();
        return I2C${instanceNumber}_RX;
    } else {
        *${componentName}_Status.data_ptr = ${componentName}_HostGetRxData();
        ${componentName}_Status.data_ptr++;
        ${componentName}_Status.bufferFree = true;
        switch (${componentName}_Status.callbackTable[I2C${instanceNumber}_DATA_COMPLETE](${componentName}_Status.callbackPayload[I2C${instanceNumber}_DATA_COMPLETE])) {
        case I2C${instanceNumber}_RESTART_WRITE:
        case I2C${instanceNumber}_RESTART_READ:
            return ${componentName}_DO_RX_NACK_RESTART();
        default:
        case I2C${instanceNumber}_CONTINUE:
        case I2C${instanceNumber}_STOP:
            return ${componentName}_DO_RX_NACK_STOP();
        }
    }
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_TX_EMPTY(void)
{
    if (${componentName}_HostIsNack()) // Client replied with NACK
    {
        switch (${componentName}_Status.callbackTable[I2C${instanceNumber}_DATA_NACK](${componentName}_Status.callbackPayload[I2C${instanceNumber}_DATA_NACK])) {
        case I2C${instanceNumber}_RESTART_READ:
            return ${componentName}_DO_SEND_RESTART_READ();
        case I2C${instanceNumber}_RESTART_WRITE:
            return ${componentName}_DO_SEND_RESTART_WRITE();
        default:
        case I2C${instanceNumber}_CONTINUE:
        case I2C${instanceNumber}_STOP:
            return ${componentName}_DO_SEND_STOP();
        }
    } else {
        ${componentName}_Status.bufferFree = true;
        switch (${componentName}_Status.callbackTable[I2C${instanceNumber}_DATA_COMPLETE](${componentName}_Status.callbackPayload[I2C${instanceNumber}_DATA_COMPLETE])) {
        case I2C${instanceNumber}_RESTART_READ:
            return ${componentName}_DO_SEND_RESTART_READ();
        case I2C${instanceNumber}_RESTART_WRITE:
            return ${componentName}_DO_SEND_RESTART_WRITE();
        case I2C${instanceNumber}_CONTINUE:
            return ${componentName}_DO_TX();
        default:
        case I2C${instanceNumber}_STOP:
            return ${componentName}_DO_SEND_STOP();
        }
    }
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_BUS_COLLISION(void)
{
    // Clear bus collision status flag
    ${componentName}_HostClearBusCollision();

    ${componentName}_Status.error = I2C${instanceNumber}_FAIL;
    switch (${componentName}_Status.callbackTable[I2C${instanceNumber}_WRITE_COLLISION](${componentName}_Status.callbackPayload[I2C${instanceNumber}_WRITE_COLLISION])) {
    case I2C${instanceNumber}_RESTART_READ:
        return ${componentName}_DO_SEND_RESTART_READ();
    case I2C${instanceNumber}_RESTART_WRITE:
        return ${componentName}_DO_SEND_RESTART_WRITE();
    default:
        ${componentNameLowerCase}ErrorState = ${moduleGroupNameUpperCase}_ERROR_BUS_COLLISION;
        return ${componentName}_DO_RESET();
    }
}

static ${componentNameLowerCase}_fsm_states_t ${componentName}_DO_BUS_ERROR(void)
{
    ${componentName}_HostResetBus();
    ${componentName}_Status.busy  = false;
    ${componentName}_Status.error = I2C${instanceNumber}_FAIL;
    return I2C${instanceNumber}_RESET; // park the FSM on reset
}

void ${componentName}_HostIsr(void)
{
    ${componentName}_HostClearIrq();

    // NOTE: We are ignoring the Write Collision flag.

    // Address phase received NACK from Client, override next state
    if (${componentName}_Status.addressNACKCheck && ${componentName}_HostIsNack()) {
        ${componentName}_Status.state = I2C${instanceNumber}_ADDRESS_NACK; // State Override
    }

    // Bus arbitration lost to another host, override next state
    if (${componentName}_HostArbitrationlostOverride()) {
        ${componentName}_Status.state = I2C${instanceNumber}_BUS_COLLISION; // State Override
    }

    // Bus error, override next state
    if (${componentName}_HostBusErrorOverride()) {
        ${componentName}_Status.state = I2C${instanceNumber}_BUS_ERROR; // State Override
    }

    ${componentName}_Status.state = ${componentName}_fsmStateTable[${componentName}_Status.state]();
}

/************************************************************************/
/* Helper Functions                                                     */
/************************************************************************/
static ${componentNameLowerCase}_operations_t ${componentName}_RETURN_STOP(void *p)
{
    return I2C${instanceNumber}_STOP;
}

static ${componentNameLowerCase}_operations_t ${componentName}_RETURN_RESET(void *p)
{
    return I2C${instanceNumber}_RESET_LINK;
}

static void ${componentName}_set_callback(${componentName}_callbackIndex_t idx, ${componentNameLowerCase}_callback_t cb, void *funPtr)
{
    if (cb) {
        ${componentName}_Status.callbackTable[idx]   = cb;
        ${componentName}_Status.callbackPayload[idx] = funPtr;
    } else {
        ${componentName}_Status.callbackTable[idx]   = ${componentName}_RETURN_STOP;
        ${componentName}_Status.callbackPayload[idx] = NULL;
    }
}

/* Host Definitions */
static inline void ${componentName}_HostOpen(void)
{
    ${moduleInstance}.MCTRLA = 1 << TWI_ENABLE_bp;
}

static inline void ${componentName}_HostClose(void)
{
    ${moduleInstance}.MCTRLA = 0 << TWI_ENABLE_bp;
}

/* Interrupt Control */
static inline void ${componentName}_HostEnableIrq(void)
{
    ${moduleInstance}.MCTRLA |= (TWI_RIEN_bm | TWI_WIEN_bm);
}

static inline bool ${componentName}_HostIsIrqEnabled(void)
{
    return ((${moduleInstance}.MCTRLA & TWI_WIEN_bm) && (${moduleInstance}.MCTRLA & TWI_RIEN_bm));
}

static inline void ${componentName}_HostDisableIrq(void)
{
    ${moduleInstance}.MCTRLA &= ~(TWI_RIEN_bm | TWI_WIEN_bm);
}

static inline void ${componentName}_HostClearIrq(void)
{
    ${moduleInstance}.MSTATUS |= (TWI_RIF_bm | TWI_WIF_bm);
}

static inline bool ${componentName}_HostBusErrorOverride(void)
{
    return ${moduleInstance}.MSTATUS & TWI_BUSERR_bm;
}

static inline bool ${componentName}_HostArbitrationlostOverride(void)
{
    return ${moduleInstance}.MSTATUS & TWI_ARBLOST_bm;
}

static inline void ${componentName}_HostResetBus(void)
{
    ${moduleInstance}.MCTRLB |= TWI_FLUSH_bm;
    ${moduleInstance}.MSTATUS |= TWI_BUSSTATE_IDLE_gc;
}

static inline void ${componentName}_HostIsRxOrTx(void)
{
    ${moduleInstance}.MCTRLB |= TWI_MCMD_RECVTRANS_gc;
}

static inline void ${componentName}_HostClearBusCollision(void)
{
    ${moduleInstance}.MSTATUS |= TWI_ARBLOST_bm;
}

static inline void ${componentName}_HostWaitForEvent(void)
{
   while (!(${moduleInstance}.MSTATUS & TWI_RIF_bm) && !(${moduleInstance}.MSTATUS & TWI_WIF_bm)) 
   {
   };
}

static inline void ${componentName}_HostStop(void)
{
    ${moduleInstance}.MCTRLB |= TWI_MCMD_STOP_gc;
}

static inline bool ${componentName}_HostIsNack(void)
{
    return ${moduleInstance}.MSTATUS & TWI_RXACK_bm;
}

static inline uint8_t ${componentName}_HostGetRxData(void)
{
    return ${moduleInstance}.MDATA;
}

static inline void ${componentName}_HostTxData(uint8_t d)
{
    ${moduleInstance}.MDATA = d;
}

static inline void ${componentName}_HostTxAddr(uint8_t d)
{
    ${moduleInstance}.MADDR = d;
}

static inline void ${componentName}_HostSendAck(void)
{
    ${moduleInstance}.MCTRLB &= ~(1 << TWI_ACKACT_bp);
}

static inline void ${componentName}_HostSendNack(void)
{
    ${moduleInstance}.MCTRLB |= TWI_ACKACT_NACK_gc;
}

${componentNameLowerCase}_operations_t ${api.CallbackReturnStop.name}(void *funPtr)
{
    return I2C${instanceNumber}_STOP;
}

${componentNameLowerCase}_operations_t ${api.CallbackReturnReset.name}(void *funPtr)
{
    return I2C${instanceNumber}_RESET_LINK;
}

${componentNameLowerCase}_operations_t ${api.CallbackRestartWrite.name}(void *funPtr)
{
    return I2C${instanceNumber}_RESTART_WRITE;
}

${componentNameLowerCase}_operations_t ${api.CallbackRestartRead.name}(void *funPtr)
{
    return I2C${instanceNumber}_RESTART_READ;
}

static  ${componentNameLowerCase}_operations_t rdBlkRegCompleteHandler(void *ptr)
{
     ${componentNameUpperCase}_SetBuffer((( ${componentNameLowerCase}_buffer_t *)ptr)->data,(( ${componentNameLowerCase}_buffer_t*)ptr)->len);
     ${componentNameUpperCase}_SetDataCompleteCallback(NULL,NULL);
    return  ${componentNameUpperCase}_RESTART_READ;
}

/**
 Section: Driver Interface Function Definitions
*/
bool ${componentNameUpperCase}_Write(uint16_t address, uint8_t *data, size_t dataLength)
{
    bool status = true;
    while(!${api.Open.name}(address)); // sit here until we get the bus..
    ${api.SetBuffer.name}(data,dataLength);
    ${api.SetAddressNackCallback.name}(NULL,NULL); //NACK polling?
    ${api.HostWrite.name}();
    while(${componentNameUpperCase}_BUSY == ${api.Close.name}());
    return status;
}

bool ${componentNameUpperCase}_Read(uint16_t address, uint8_t *data, size_t dataLength)
{
    bool status = true;
    while(!${api.Open.name}(address)); // sit here until we get the bus..
    ${api.SetBuffer.name}(data,dataLength);
    ${api.HostRead.name}();
    while(${componentNameUpperCase}_BUSY == ${api.Close.name}()); // sit here until finished.
    return status;
}

bool ${componentNameUpperCase}_WriteRead(uint16_t address, uint8_t *writeData, size_t writeLength, uint8_t *readData, size_t readLength)
{
    bool status = true;
    ${componentNameLowerCase}_buffer_t bufferBlock; // result is little endian
    bufferBlock.data = readData;
    bufferBlock.len = readLength;
    while(!${api.Open.name}(address)); // sit here until we get the bus..
    ${api.SetDataCompleteCallback.name}(rdBlkRegCompleteHandler,&bufferBlock);
    ${api.SetBuffer.name}(writeData,writeLength);
    ${api.SetAddressNackCallback.name}(NULL,NULL); //NACK polling?
    ${api.HostWrite.name}();
    while(${componentNameUpperCase}_BUSY == ${api.Close.name}()); // sit here until finished.    
    return status;
}

bool ${componentNameUpperCase}_TransferSetup(struct ${moduleGroupNameUpperCase}_TRANSFER_SETUP *setup, uint32_t srcClkFreq)
{
    bool status = false;
    return status;
}

enum ${moduleGroupNameUpperCase}_ERROR ${componentNameUpperCase}_ErrorGet(void)
{
    return ${componentNameLowerCase}ErrorState;
}

bool ${componentNameUpperCase}_IsBusy(void)
{
    return ${componentNameUpperCase}_Status.inUse;
}

void ${componentNameUpperCase}_Callback(void)
{
    
}

void ${componentNameUpperCase}_CallbackRegister(void (*handler)(void))
{
    ${componentNameUpperCase}_InterruptHandler = handler;
}